;************************************************************
;This small program will calculate your payments on a loan
; I don't know if it will work on any currency, but it works 
; well in North America. - blueb - Jan 2004
; Public Domain.
; Used: PB 3.81 and PureVision 1.64
; Hardest part was creating an "AddMonths" function that takes
; into consideration leap years, etc. Hope I got it right!
;*************************************************************

Structure ColorGadgets
  Gadget.l
  FGColor.l
  BGColor.l
  rFace.l
  rBrush.l
EndStructure
NewList CG.ColorGadgets()

Structure AmortizeTable
    pmt_Date.s
    Loan_Bal.s
    Rate.s
    Pmt_Amt.s
    To_Interes.s
    To_Princip.s
    Tot_Pmts.s
    Tot_Int.s
    Tot_Prin.s
EndStructure
Dim Rec.AmortizeTable(600) ; Enough for 50 years of monthly payments

Procedure ColorGadgets_Add(GadgetID.l,FGColor.l,BGColor.l)
  ForEach CG()
    If CG()\Gadget=GadgetID
      DeleteObject_(CG()\rFace)
      DeleteObject_(CG()\rBrush)
      DeleteElement(CG())
      Break
    EndIf
  Next
  AddElement(CG())
  CG()\Gadget=GadgetID
  CG()\FGColor=FGColor
  CG()\BGColor=BGColor
  CG()\rFace=CreateSolidBrush_(GetSysColor_(#COLOR_BTNFACE))
  CG()\rBrush=CreateSolidBrush_(BGColor)
EndProcedure

;-Window Constants
Enumeration
  #Window_Main
  #Window_Info
EndEnumeration
#WindowIndex=#PB_Compiler_EnumerationValue

;-Gadget Constants
Enumeration
  ;Window_Main
  #Gadget_Main_Image2
  #Gadget_Main_Text3
  #Gadget_Main_Frame3D4
  #Gadget_Main_PrintBtn
  #Gadget_Main_QuitBtn
  #Gadget_Main_InfoBtn
  #Gadget_Main_Text8
  #Gadget_Main_Text9
  #Gadget_Main_Text8_10
  #Gadget_Main_Text8_11
  #Gadget_Main_Text8_12
  #Gadget_Main_Text8_13
  #Gadget_Main_RateStr
  #Gadget_Main_AmtStr
  #Gadget_Main_YearsStr
  #Gadget_Main_CalcStr
  #Gadget_Main_DateStr
  #Gadget_Main_Text99
  ;Window_Info
  #Gadget_Info_Text23
  #Gadget_Info_String22

EndEnumeration
#GadgetIndex=#PB_Compiler_EnumerationValue

;-Image Constants
Enumeration
  #Image_Main_Image2

EndEnumeration
#ImageIndex=#PB_Compiler_EnumerationValue

#CRLF = Chr(13) + Chr(10)

;-Load Images
CatchImage(#Image_Main_Image2,?_IMG_Main_Image2)

DataSection
  _IMG_Main_Image2:IncludeBinary "Hoppy2.bmp"
EndDataSection

;-Declaration Section
Global OriginalDay.s

Declare WindowCallback(WindowID,Message,wParam,lParam)
Declare.s AddMonths(DateInfo.s, MonthNum.l)
Declare CalculatePayments()
Declare Print_Btn()

;==========================================================================================
Procedure.l Window_Main()
  If OpenWindow(#Window_Main,246,-6,548,371,#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_Invisible,"Bare Point Systems")
    Brush.LOGBRUSH\lbColor=15918822
    SetClassLong_(WindowID(#Window_Main),#GCL_HBRBACKGROUND,CreateBrushIndirect_(Brush))
    If CreateGadgetList(WindowID(#Window_Main))
      ImageGadget(#Gadget_Main_Image2,15,80,140,263,UseImage(#Image_Main_Image2),#PB_Image_Border)
      TextGadget(#Gadget_Main_Text3,85,10,375,55,"Investment Warrior",#PB_Text_Center)
        ColorGadgets_Add(#Gadget_Main_Text3,128,12058111)
        SetGadgetFont(#Gadget_Main_Text3,LoadFont(#Gadget_Main_Text3,"Highlight LET",26,0))
      Frame3DGadget(#Gadget_Main_Frame3D4,165,75,360,190,"")
        SetGadgetFont(#Gadget_Main_Frame3D4,LoadFont(#Gadget_Main_Frame3D4,"Arial",9,0))
      ButtonGadget(#Gadget_Main_PrintBtn,165,280,360,35,"Print Amortization Schedule")
        SetGadgetFont(#Gadget_Main_PrintBtn,LoadFont(#Gadget_Main_PrintBtn,"Verdana",9,0))
      ButtonGadget(#Gadget_Main_QuitBtn,460,325,65,25,"Quit")
      ButtonGadget(#Gadget_Main_InfoBtn,170,325,95,25,"Information")
      TextGadget(#Gadget_Main_Text8,185,155,185,15,"Loan Amount (Dollars):",#PB_Text_Right)
        ColorGadgets_Add(#Gadget_Main_Text8,128,15918822)
      TextGadget(#Gadget_Main_Text9,190,45,150,20,"Amortization Tables")
        ColorGadgets_Add(#Gadget_Main_Text9,128,12058111)
        SetGadgetFont(#Gadget_Main_Text9,LoadFont(#Gadget_Main_Text9,"VAG Round",12,0))
      TextGadget(#Gadget_Main_Text99,395,105,70,16,"mm/dd/yyyy",#PB_Text_Center)
        ColorGadgets_Add(#Gadget_Main_Text99,128,15918822)
       
      TextGadget(#Gadget_Main_Text8_10,185,185,185,15,"Interest Rate (%):",#PB_Text_Right)
        ColorGadgets_Add(#Gadget_Main_Text8_10,128,15918822)
      TextGadget(#Gadget_Main_Text8_11,185,215,185,15,"Length of Loan (Years):",#PB_Text_Right)
        ColorGadgets_Add(#Gadget_Main_Text8_11,128,15918822)
      TextGadget(#Gadget_Main_Text8_12,185,245,185,15,"Calculated Monthly Payment:",#PB_Text_Right)
        ColorGadgets_Add(#Gadget_Main_Text8_12,128,15918822)
      TextGadget(#Gadget_Main_Text8_13,185,125,185,15,"Date of First Payment:",#PB_Text_Right)
        ColorGadgets_Add(#Gadget_Main_Text8_13,128,15918822)
      
      myDate.s = FormatDate( "%mm/%dd/%yyyy", Date()) ; today
      StringGadget(#Gadget_Main_DateStr,385,120,80,20,myDate,#PB_Text_Right)
      StringGadget(#Gadget_Main_AmtStr,385,150,80,20,"5000.00",#PB_Text_Right)
      StringGadget(#Gadget_Main_RateStr,385,180,80,20,"4.00",#PB_Text_Right)
      StringGadget(#Gadget_Main_YearsStr,385,210,80,20,"1.0",#PB_Text_Right)
      StringGadget(#Gadget_Main_CalcStr,385,240,80,20,"blank",#PB_Text_Right)
 
      HideWindow(#Window_Main,0)
      DisableGadget(#Gadget_Main_PrintBtn, 1) 
      ActivateGadget(#Gadget_Main_DateStr)
    
      ProcedureReturn WindowID()
    EndIf
  EndIf
EndProcedure
;======================================================================================
Procedure.l Window_Info()
  If OpenWindow(#Window_Info,250,12,400,300,#PB_Window_SystemMenu|#PB_Window_WindowCentered|#PB_Window_Invisible,"Information")
    Brush.LOGBRUSH\lbColor=16769217
    SetClassLong_(WindowID(#Window_Info),#GCL_HBRBACKGROUND,CreateBrushIndirect_(Brush))
    If CreateGadgetList(WindowID(#Window_Info))
      TextGadget(#Gadget_Info_Text23,100,10,185,20,"General Information",#PB_Text_Center)
        ColorGadgets_Add(#Gadget_Info_Text23,16711680,16769217)
        SetGadgetFont(#Gadget_Info_Text23,LoadFont(#Gadget_Info_Text23,"Verdana",10,256))
      StringGadget(#Gadget_Info_String22,35,95,320,140,"Freeware. Use as you see fit. I'm not responsible for any errors. Period." + #CRLF + #CRLF + "In the future, I hope to implement a way to pay off your loan faster... by simply overwriting the amount in the 'Calculated Monthly Payment' field." + #CRLF + #CRLF + "Your loan length, etc. would be reduced accordingly.",#PB_String_ReadOnly|#PB_String_MultiLine|#PB_Text_Center|#PB_Text_Right)
      HideWindow(#Window_Info,0)
      ProcedureReturn WindowID()
    EndIf
  EndIf
EndProcedure

;=========================================================
Procedure WindowCallback(WindowID,Message,wParam,lParam)
  ReturnValue=#PB_ProcessPureBasicEvents
  If Message=#WM_CTLCOLORSTATIC Or Message=#WM_CTLCOLOREDIT Or Message=#WM_CTLCOLORLISTBOX
    ForEach CG()
      If GadgetID(CG()\Gadget)=lParam
        SetTextColor_(wParam,CG()\FGColor)
        SetBkMode_(wParam,#TRANSPARENT)
        If CG()\BGColor=0
          SetBkColor_(wParam,CG()\rFace)
          ReturnValue=CG()\rFace
          Else
          SetBkColor_(wParam,CG()\BGColor)
          ReturnValue=CG()\rBrush
        EndIf
      EndIf
    Next
  EndIf
  ProcedureReturn  ReturnValue
EndProcedure
;========================================================================

;-Main Loop
If Window_Main()
  SetWindowCallback(@WindowCallback())
  
  quitMain=0
  Repeat
    EventID=WaitWindowEvent()

    Select EventID
    
      Case #PB_Event_CloseWindow
        If EventWindowID()=#Window_Main
          quitMain=1
        ElseIf EventWindowID()=#Window_Info
          CloseWindow(#Window_Info)
        EndIf

      Case #PB_Event_Gadget
        
        Select EventGadgetID()

          Case #PB_Key_Tab 
                  CalculatePayments()
          
          Case #Gadget_Main_PrintBtn
                  Print_Btn()

          Case #Gadget_Main_QuitBtn
                quitMain=1

          Case #Gadget_Main_InfoBtn
                Window_Info()
                              
          Case #Gadget_Main_RateStr
          Case #Gadget_Main_AmtStr
          Case #Gadget_Main_YearsStr
          Case #Gadget_Main_CalcStr
          Case #Gadget_Main_DateStr
                

        EndSelect

    EndSelect
  Until quitMain
  CloseWindow(#Window_Main)
EndIf

End

;======================================================================================
Procedure.s AddMonths(DateInfo.s, MonthNum.l)
;Useful for calculating amortization payment dates, etc.
;Note: Considers leap years.
;        USEAGE:  ret.s = AddMonths("11-30-1999", 3)
;                 ret.s returns a value of: "02-29-2000"
; -------------------------------------------------------

; Parse DateInfo
Month.s = Mid(DateInfo, 1, 2)
Day.s = Mid(DateInfo, 4, 2)
Year.s = Mid(DateInfo, 7, 4)

; Check the MonthNum for validity
If MonthNum < 1 Or MonthNum > 12
   MessageRequester("", "The Month needs to be a" +Chr(10) + "number between 1 And 12.", 0)
   ProcedureReturn   ;exit procedure
EndIf

; Check for users mis-entering 30 day months
If Val(Month) = 4 And Val(Day) = 31
   MessageRequester("", "There are only 30 days in April.", 0)
   ProcedureReturn   ;exit procedure
EndIf
If Val(Month) = 6 And Val(Day) = 31
   MessageRequester("", "There are only 30 days in June.", 0)
   ProcedureReturn   ;exit procedure
EndIf
If Val(Month) = 9 And Val(Day) = 31
   MessageRequester("", "There are only 30 days in September.", 0)
   ProcedureReturn   ;exit procedure
EndIf
If Val(Month) = 11 And Val(Day) = 31
   MessageRequester("", "There are only 30 days in November.", 0)
   ProcedureReturn   ;exit procedure
EndIf
    
; First set a flag that only checks the users date information one time
Global DoOnce.l; Check DateInfo information for validity. 
If DoOnce = 0
    If Val(Day) > 31 
       ret.l = 1
    EndIf
    ; 
    If Val(Year) < 1800 Or Val(Year) > 2200 ;seems like a good limit
       ret.l =  1
    EndIf
    ; Check for leap year on user's date string
    If Val(month) = 2 And Val(Day) > 28
        temp.l = Val(Year)
        If MOD(temp,400) <> 0
            ret = 1
            If MOD(temp,100) <> 0
                ret = 1
            EndIf
         EndIf
      
    EndIf
    ; 
    If Val(month) > 12
        ret = 1
    EndIf
    ; 
    If ret = 1
        MessageRequester("", "Your date string is not valid, Please re-start program.", 0)
        End
    EndIf
EndIf        
; -----------------------------------------------------------------
; Finished with date checks. Now add the required Months to the Date
; -----------------------------------------------------------------
; 
; Add to a temp value.
t.l = Val(Month) + MonthNum

; If the year rolls over... add a year and adjust the month number.
If t > 12
  t = t - 12
  Year = Str(Val(Year) + 1)
EndIf
temp.l = Val(Year)

; Needed for date values later
If t < 10
  Month = "0" + Str(t)
Else
  Month = Str(t)
EndIf
  
; Adjust values, depending on the month number.
Select t
      Case 2 ; If it's February...
          If Val(Day) > 28  ; check for leap year.
             Day = "29" 
             If MOD(temp,400) <> 0
                  Day = "29"
                  If MOD(temp,100) <> 0
                    Day = "29"
                    If MOD(temp,4) <> 0
                        Day = "28" ;not divisble by 4 so use the 28th as date
                    EndIf                     
                 EndIf
              EndIf
          EndIf
          
          NewDate.s = Month + "/" + Day + "/" + Year
          
       Default ; use on all other months - check for 30 day months
              Day = OriginalDay
              t2.l = Val(Day)
              Select t2
                    Case = 31
                         Select Val(Month)
                              Case 4
                                 Day = "30"
                              Case 6
                                 Day = "30"
                              Case 9
                                 Day = "30"
                              Case 11
                                 Day = "30"
                             Default
                                 Day = "31"
                          EndSelect

                     Default
                       NewDate.s = Month + "/" + Day + "/" + Year
                     
               EndSelect
       
          NewDate.s = Month + "/" + Day + "/" + Year
          
EndSelect
DoOnce = 1
ProcedureReturn NewDate
EndProcedure
;================================================================================
Procedure CalculatePayments()
;Activate the Print Button....
DisableGadget(#Gadget_Main_PrintBtn, 0)

;Dimension the variables I require....
t.l
pmt_date.s
remaining.f
crate.f
rate.f
payment.f
cpayment.f
to_int.f
to_prin.f
no_of_pmts.f
pmt_total.f
int_total.f
prin_total.f
count.l
term.f
no_of_payments.l
temp.s
iRet.l
original_date.s

 ;Dates
  pmt_date = Trim(GetGadgetText(#Gadget_Main_DateStr))
  
  ;save for later use...
  original_date = pmt_date
  
  ;Extract the 'day' value
  OriginalDay.s = Mid(original_date, 4, 2)
  If Val(OriginalDay) > 31
      MessageRequester("", "Your date string is not valid, Please re-start program.", 0)
      End
  EndIf      


  ;Get the Loan Amount
  remaining = ValF(GetGadgetText(#Gadget_Main_AmtStr))
 
 ;Interest
  rate = ValF(GetGadgetText(#Gadget_Main_RateStr))
  crate = rate
  
 ;Term of Loan 
  term.f = ValF(GetGadgetText(#Gadget_Main_YearsStr))
  
 ;Loan Amount 
  Principal.f = ValF(GetGadgetText(#Gadget_Main_AmtStr))
  
  ;Monthly payment calculation
  ;~~~~~~~~~~~~~~~~~~~~~~~~~~~
  trate.f = (rate/100)/12
  no_of_payments = term * 12

  tempvalue.f = 1 + trate
  factor.f = Pow(tempvalue, no_of_payments) 
  payment = (principal * factor) / (((factor - 1) / trate))
  cpayment = payment
 
  SetGadgetText(#Gadget_Main_CalcStr, StrF(payment.f, 2))
  ActivateGadget(#Gadget_Main_AmtStr)
;************************************************************************************
  ;Step #2 - put all the information into a database of some sort....hmmm.
  ;Decided to use a simple structure, so forum users can see that structures/arrays
  ;can do the job without an actual database file or ODBC. 
  
  ;Use AmortizeTable Structure
  ;Rec.AmortizeTable(600) - Enough for 50 years of monthly payments (see top of page)
;************************************************************************************

;open and zap the Loan File
If CreateFile(0, "Loan.txt") = 0
    MessageRequester("Error", "Unable to create a file, be sure LOAN.TXT is not in use", 0)
    End
EndIf
;This is the file header information for LOAN.TXT
Headera.s = "                                                                 |-----------  Totals ------------|" 
Headerb.s = "  Due Date     Balance  Rate    Payment    Interest   Principal      Paid      Interest   Principal"
Header1.s = ""
Header2.s = "___________________________________________________________________________________________________"

;first zero temp info
count = 0
pmt_total = 0
int_total = 0
prin_total = 0

For count = 0 To no_of_payments
  If remaining <= 0.01
      Break  ; exit the For Loop
  EndIf
  
  to_int = (remaining * rate) / 1200 ; get int. amount
   
  If cpayment > remaining          ;recalc if amount is less than reg. payment
    cpayment = remaining + to_int  ;due to making a larger than normal payment. 
    payment = cpayment
  EndIf
  
  to_prin = payment - to_int        ;get principal amount
  pmt_total = pmt_total + cpayment  ;update total fields
  int_total = int_total + to_int
  prin_total = prin_total + to_prin
  remaining = remaining - (payment - to_int) ; update remaining balance

  ;place this info into a record
  Rec(no_of_payments)\pmt_Date = pmt_date.s
  Rec(no_of_payments)\Loan_Bal = StrF(remaining, 2)
  Rec(no_of_payments)\Rate = StrF(crate, 2)
  Rec(no_of_payments)\Pmt_Amt = StrF(cpayment, 2)
  Rec(no_of_payments)\To_Interes = StrF(to_int, 2)
  Rec(no_of_payments)\To_Princip = StrF(to_prin, 2)
  Rec(no_of_payments)\Tot_Pmts = StrF(pmt_total, 2)
  Rec(no_of_payments)\Tot_Int = StrF(int_total, 2)
  Rec(no_of_payments)\Tot_Prin = StrF(prin_total, 2)
  ;Write each record to the file....
  ;Add data to LOAN.TXT
  Part1.s = RSet(Rec(no_of_payments)\pmt_Date, 10)
  Part2.s = RSet(Rec(no_of_payments)\Loan_Bal, 12)
  Part3.s = RSet(Rec(no_of_payments)\Rate, 6)
  Part4.s = RSet(Rec(no_of_payments)\Pmt_Amt, 10)
  Part5.s = RSet(Rec(no_of_payments)\To_Interes, 12)
  Part6.s = RSet(Rec(no_of_payments)\To_Princip, 12)
  Part7.s = RSet(Rec(no_of_payments)\Tot_Pmts, 12)
  Part8.s = RSet(Rec(no_of_payments)\Tot_Int, 12)
  Part9.s = RSet(Rec(no_of_payments)\Tot_Prin, 12)
  Record.s = Part1 + Part2 + Part3 + Part4 + Part5 + Part6 + Part7 + Part8 + Part9

  ;Add years to the printout
  If MOD(count, 12) = 0
    add.l = add + 1
    WriteStringN("")
    WriteStringN(Headera)
    WriteStringN(Headerb)
    WriteStringN(Header1)
    WriteStringN("Year:" + Str(add))
  EndIf
  
  ; write one line to the printout
  WriteStringN(Record)
     
  ;increment payment date by one month
   pmt_date =  AddMonths(pmt_date, 1)
Next 

CloseFile(0)
EndProcedure
;===================================================================
Procedure Print_Btn()
  MessageRequester("Please Note", "For proper alignment use a small non-proportional font (e.g. Courier 8) with NotePad", 0)
  RunProgram("notepad.exe", "Loan.txt", "", 1) 
EndProcedure
;===================================================================

; ExecutableFormat=Windows
; CursorPosition=99
; FirstLine=91
; EnableXP
; Executable=C:\PureBasic\BobDev\Amortize\Amortize.exe
; DisableDebugger
; EOF